
#include "stdafx.h"

#include "convert.h"



/* t is buffer space of size BUFFSIZE */

static char *lower(char *s,char * t)
{
 int i = 0;

 strcpy(t, s);
 while(t[i] != '\0')
 {
  t[i] = tolower(t[i]);
  ++i;
 }
 return(t);
}

int style(void)
{
 int i;
 char t[BUFFSIZE];
 char scrap1[BUFFSIZE];
 char scrap2[BUFFSIZE];

 if (!strcmp("style", s) || !strcmp("ruler", s))
  getword();

/* if(strlen(s) > 18)
 {
  s[17] = '\"';
  s[18] = '\0';
 } */


 if(strlen(s)>18)
 {
  s[18]='\0';
 }

 strcpy(t,s);

 for(i=0;(i<styleno) && strcmp(lower(st[i],scrap1),lower(s,scrap2));i++);
 getword();

 if(ls[i]) localruler(i);
 else
 {
  if(strcmp("on",s) && strcmp("off",s)) return(1);
  else
  {
   fprintf(out,"{%suserstyle {stylename \"%s\"}}", strcmp("on", s) ? "rem" : "add", (i || !styletot) ? t : "BodyText");
  }
 }
 return(0);
}

void localruler(int i)
{
 char *cpy;

 leoff = !strcmp("off", s);
 cpy = p;
 p = (char *)ls[i];
 getword();
 getword();
 commands();
 p = cpy;
 leoff = 0;  
}

void newpage(void)
{
 fprintf(out, "{newpage}");
}

void code(void)
{
 fprintf(out, "\"%c\"", (char)strtol(s+1, NULL, 10));
}

void tab(void)
{
 fprintf(out, "{tab}");
}

void newpara(void)
{
 fprintf(out, "{newpara}");
}

void star(void)
{
 fprintf(out, "*");
}

void hash(void)
{
 fprintf(out, "#");
}

void at(void)
{
 fprintf(out, "@");
}

void hyphen(void)
{
 fprintf(out, "{softhyphen}");
}

void kern(void)
{
 fprintf(out, "{track");
 if (*p != '}')
 {
  fprintf(out, " 0x%x}{track", strtol(getword(), NULL, 10) * 0x10000 / 1000);
  getword();
 }
 nl();
}

void define(void)
{
 while(*p != '}' && p != end)
  ++p;
}

void font(void)
{
  fprintf(out, "{fontstyle");
  if (*p != '}')
  {
    fprintf(out, " \"%s\"", getword());
    if(def==0)
      strcpy(f, s);
    if (beffect >= 0)
    {
      nl();
      fprintf(out, "{bold %d", beffect);
    }
    if (ieffect >= 0)
    {
      nl();
      fprintf(out, "{italic %d", ieffect);
    }
  }
  else
    if(def==0)
      strcpy(f, "");    
  nl();
}

void nl(void)
{
  fprintf(out, "}%s", def ? "\r\n" : "");
}

void fontsize(void)
{
  fprintf(out, "{textsize");
  if (*p != '}')
    fprintf(out, " %.0f",value());
  nl();
}

double value(void)
{
  char *e;
  double v;

  v = strtod(getwords(), &e);


  while (*e == 10 || *e == ' ' && e != end)
    *e++;

  if (!strcmp("mm", e)) return v * 72000 / 25.4;
  if (!strcmp("cm", e)) return v * 720000 / 25.4;
  if (!strcmp("m", e)) return v * 72000000 / 25.4;
  if (!strcmp("in", e) || strstr("\"", e)) return v * 72000;
  if (!strcmp("yd", e)) return v * 36 * 72000;
  if (!strcmp("ft", e) || strstr("'", e)) return v * 12 * 72000;
  if (!strcmp("pi", e)) return v * 12000;
  if (!strcmp("%", e)) return v * 0x10000 / 100;
  return v * 1000;
}



void linespace(void)
{
  fprintf(out, "{leading");
  if (*p != '}')
    fprintf(out, " 1 %.0f", value());
  nl();
}

void spaceabove(void)
{
 if(*p!='}')   // DJP 10/2/2007
  fprintf(out, "{spacebefore %.0f\r\n", value());
 else
  fprintf(out, "{spacebefore");
 nl();
}

void spacebelow(void)
{
 if(*p!='}')   // DJP 10/2/2007
  fprintf(out, "{spaceafter %.0f\r\n", value());
 else
  fprintf(out, "{spaceafter");
 nl();
}

void leftmargin(void)
{
  fprintf(out, "{leftindent");
  if (!leoff && *p!='}')   // DJP 10/2/2007
    fprintf(out, " 1 %.0f", li = value());
  else
    skipcommand();
  nl();
}

void rightmargin(void)
{
  double v;

  fprintf(out, "{rightindent");
  if (!leoff && *p!='}')   // DJP 10/2/2007
  {
    v = value();
    fprintf(out, " %d %.0f", (v > 0) ? 2 : 0, fabs(v));
  }
  else
    skipcommand();
  nl();
}

void returnmargin(void)
{
  fprintf(out, "{firstindent");
  if (!leoff && *p!='}')   // DJP 10/2/2007
    fprintf(out, " %.0f", value() - li);
  else
    skipcommand();
  nl();
}

void linespacep(void)
{
  fprintf(out, "{leading");
  if (*p != '}')
    fprintf(out, " 2 0x%x", (int)value() - 0x10000);
  nl();
}

void tracking(void)
{
  fprintf(out, "{track");
  if (*p != '}')
    fprintf(out, " 0x%x", strtol(getword(), NULL, 10));
  nl();
}

void fontcolour(void)
{
  fprintf(out, "{foreground");
  if (*p != '}')
    fprintf(out, " COL_%d 0x10000", collookup());
  nl();
}

void backcolour(void)
{
  fprintf(out, "{background COL_%d 0x10000}\r\n", collookup());
}

int collookup(void)
{
  int i = 0;
  char *s1 = s;

  getword();
  if(s[0] == '\"')
  {
    s[strlen(s) - 1] = '\0';
    ++s1;
  }
  while (strcmp(ct[i], s1) && i < colno) i++;
  if (i == colno)
    error("Colour not found");
  return i;
}

void fontaspect(void)
{
  fprintf(out, "{scale");
  if (*p != '}')
    fprintf(out, " 0x%x", (int)value());
  nl();
}

void bold(void)
{
 beffect = -1;
 fprintf(out,"{bold");
 if(*p!= '}')
	{
		beffect=strcmp("on",getword())?0:1;
  fprintf(out," %d",beffect);
	}
 else
 if(f[0]!='\0')
 {
  nl();
  fprintf(out, "{fontstyle \"%s\"", f);
 }
 nl();
}

void italic(void)
{
  ieffect = -1;
  fprintf(out, "{italic");
  if (*p != '}')
    fprintf(out, " %d", ieffect = strcmp("on", getword()) ? 0 : 1);
  else
    if(f[0] != '\0')
    {
      nl();
      fprintf(out, "{fontstyle \"%s\"", f);
    }
  nl();
}

void script(void)
{
  if (*p == '}')
    fprintf(out, "{sub");
  else {
    if (!strcmp("off", getword())) fprintf(out, "{super 0}{sub 0");
    if (!strcmp("super", s)) fprintf(out, "{super 1");
    if (!strcmp("sub", s)) fprintf(out, "{sub 1");
  }
  nl();
}

void underline(void)
{
  fprintf(out, "{underline");
  if (*p != '}')
  {
    getwords();
    fprintf(out, " %d {type 1} {thickness 2620} {colourvalue {colourname \"Transparent\"} 0x10000} {wordunderline 0} {doubleunderline %d}", strcmp("0", s) ? 1 : 0, strcmp("2", s) ? 0 : 1);
  }
  nl();
}

void pageno(void)
{
  getword();
  fprintf(out, "{pageno}");
}

void chapno(void)
{
  getword();
  fprintf(out, "{chapterno}");  
}

void setscope(void)
{
  scope = 1;
}

void justify(void)
{
  fprintf(out, "{align");
  if (*p != '}')
  {
    if (!strcmp("left", getword())) fprintf(out, " 0");
    if (!strcmp("centre", s)) fprintf(out, " 1");
    if (!strcmp("right", s)) fprintf(out, " 2");
    if (!strcmp("full", s)) fprintf(out, " 3");
  }
  nl();
}

void tabs(void)
{
  char *temp;

  fprintf(out, "{tabruler");
  if (!leoff)
  {
    fprintf(out, " {tableader \"%s\"} ", "");
    while(*p != '}' && *p != ';')
    {
      temp = p;
      if (!strcmp("left", gettab()))
        fprintf(out, "{lefttab");
      else if (!strcmp("right", s))
        fprintf(out, "{righttab");
      else if (!strcmp("centre", s))
        fprintf(out, "{centretab");
      else if (!strcmp("decimal", s))
        fprintf(out, "{decimaltab");
      else if (!strcmp("vertrule", s))
        fprintf(out, "{ruleposn");
      else
      {
        p = temp;
        fprintf(out, "{lefttab");
      }
    fprintf(out, " %.0f}", value());
    }
  }
  else
    skipcommand();
  nl();
}

void strikeout(void)
{
  fprintf(out, "{strikeout %d {type 1} {thickness 0} {colourvalue {colourname \"Transparent\"} 0x10000}}\r\n", strcmp("off", getword()) ? 1 : 0);
}

void hyphenate(void)
{
    fprintf(out, "{hyphenation %d {hpminsize 5} {hpminbefore 2} {hpminafter 2} {hpmaxconsecutive 3} {hpzone 36000} {hpbreakpara 0} {hpbreakcaps 0}}\r\n", !strcmp("on", getword()) ? 1 : 0);
}


void mergecommand(void)
{
 char * p;
 char * q;
 char   field[16];


 p=getword();
 q=strrchr(p,' ');
 if(!q) q=p;

 strncpy(field,q,sizeof(field));
 field[sizeof(field)-1]=0;

 fprintf(out," {merge \"%s\" \"{macv=impulse(\\\"%s\\\")}\"}\r\n",field,p);
}


